diff --git a/gcc/m2/mc/decl.mod b/gcc/m2/mc/decl.mod
index c3ee646caaf..37fc3962695 100644
--- a/gcc/m2/mc/decl.mod
+++ b/gcc/m2/mc/decl.mod
@@ -9420,11 +10311,35 @@ PROCEDURE doAssignmentC (p: pretty; s: node) ;
 BEGIN
    assert (isAssignment (s)) ;
    doCommentC (p, s^.assignmentF.assignComment.body) ;
-   doExprCup (p, s^.assignmentF.des, requiresUnpackProc (s)) ;
+   IF debugOpaque
+   THEN
+      outText (p, " /* des: */ ") ;
+      dumpOpaqueState (s^.assignmentF.des) ;
+      outText (p, " /* expr: */ ") ;
+      dumpOpaqueState (s^.assignmentF.expr)
+   END ;
+   s^.assignmentF.des := doExprCup (p, s^.assignmentF.des,
+                                    requiresUnpackProc (s), TRUE) ;
+   IF debugOpaque
+   THEN
+      outText (p, "\n /* after doExprCup des: */ ") ;
+      dumpOpaqueState (s^.assignmentF.des) ;
+      outText (p, "\n")
+   END ;
    setNeedSpace (p) ;
    outText (p, "=") ;
    setNeedSpace (p) ;
-   doExprCastC (p, s^.assignmentF.expr, getType (s^.assignmentF.des)) ;
+   IF nodeUsesOpaque (s^.assignmentF.des)
+   THEN
+      forceCastOpaque (p, s^.assignmentF.des, s^.assignmentF.expr,
+                       getNodeOpaqueVoidStar (s^.assignmentF.des))
+   ELSE
+      IF debugOpaque
+      THEN
+         outText (p, " /* no opaque des seen */ ")
+      END ;
+      doExprCastC (p, s^.assignmentF.expr, getType (s^.assignmentF.des))
+   END ;
    outText (p, ";") ;
    doAfterCommentC (p, s^.assignmentF.assignComment.after)
 END doAssignmentC ;
@@ -10058,11 +10973,11 @@ PROCEDURE doAdrExprC (p: pretty; n: node) ;
 BEGIN
    IF isDeref (n)
    THEN
-      (* (* no point in issuing & ( * n )  *) *)
+      (* No point in issuing & ( * n ).  *)
       doExprC (p, n^.unaryF.arg)
    ELSIF isVar (n) AND n^.varF.isVarParameter
    THEN
-      (* (* no point in issuing & ( * n )  *) *)
+      (* No point in issuing & ( * n ).  *)
       doFQNameC (p, n)
    ELSE
       outText (p, '&') ;
@@ -10129,7 +11044,7 @@ BEGIN
       THEN
          IF isString (actual) AND (skipType (ft) = addressN)
          THEN
-            outText (p, "const_cast<void*> (reinterpret_cast<const void*> (") ;
+            outText (p, "const_cast<void*> (static_cast<const void*> (") ;
 	    RETURN 2
          ELSIF isPointer (skipType (ft)) OR (skipType (ft) = addressN)
          THEN
@@ -10232,6 +11147,42 @@ BEGIN
 END isDefForCNode ;
 
 
+(*
+   doFuncVarParam - detect whether the formal uses an opaque and ensure that the address of
+                    the actual parameter is cast to the formal type.
+*)
+
+PROCEDURE doFuncVarParam (p: pretty; actual, formal: node) ;
+VAR
+   type: node ;
+BEGIN
+   IF nodeUsesOpaque (formal) AND
+      getNodeOpaqueFlushNecessary (actual, getNodeOpaqueVoidStar (formal))
+   THEN
+      type := getType (formal) ;
+      outText (p, 'reinterpret_cast<') ;
+      IF getNodeOpaqueVoidStar (formal)
+      THEN
+         doTypeNameC (p, type) ;
+         setNeedSpace (p) ;
+         outText (p, '*> (&') ;
+         doExprC (p, actual) ;
+         outText (p, ')') ;
+         actual := makeOpaqueCast (actual, TRUE)
+      ELSE
+         doTypeNameC (p, type) ;
+         noSpace (p) ;
+         outText (p, '__opaque *> (&') ;
+         doExprC (p, actual) ;
+         outText (p, ')') ;
+         actual := makeOpaqueCast (actual, FALSE)
+      END
+   ELSE
+      doAdrExprC (p, actual)
+   END
+END doFuncVarParam ;
+
+
 (*
    doFuncParamC -
 *)
@@ -10283,14 +11234,22 @@ BEGIN
                doCastC (p, getType (formal), actual)
             END
          ELSE
-            lbr := checkSystemCast (p, actual, formal) ;
             IF isVarParam (formal)
             THEN
-               doAdrExprC (p, actual)
+               lbr := checkSystemCast (p, actual, formal) ;
+               doFuncVarParam (p, actual, formal) ;
+               emitN (p, ")", lbr)
             ELSE
-               doExprC (p, actual)
-            END ;
-            emitN (p, ")", lbr)
+               IF nodeUsesOpaque (formal)
+               THEN
+                  forceCastOpaque (p, formal, actual,
+                                   getNodeOpaqueVoidStar (formal))
+               ELSE
+                  lbr := checkSystemCast (p, actual, formal) ;
+                  doExprC (p, actual) ;
+                  emitN (p, ")", lbr)
+               END
+            END
          END
       END
    END
@@ -10442,22 +11401,20 @@ BEGIN
    THEN
       (* & and * cancel each other out.  *)
       outTextN (p, getSymName (n))   (* --fixme-- does the caller need to cast it?  *)
-   ELSE
-      IF isString (n)
+   ELSIF isString (n) OR (isArray (getType (n)) AND isUnbounded (getType (n)))
+   THEN
+      IF lang = ansiCP
       THEN
-         IF lang = ansiCP
-         THEN
-            outText (p, "const_cast<void*> (reinterpret_cast<const void*>") ;
-            outText (p, "(") ;
-            doExprC (p, n) ;
-            outText (p, "))")
-         ELSE
-            doExprC (p, n)
-         END
+         outText (p, "const_cast<void*> (static_cast<const void*>") ;
+         outText (p, "(") ;
+         doExprC (p, n) ;
+         outText (p, "))")
       ELSE
-         outText (p, "&") ;
          doExprC (p, n)
       END
+   ELSE
+      outText (p, "&") ;
+      doExprC (p, n)
    END
 END doAdrArgC ;
 
@@ -11170,6 +12127,23 @@ END doConvertSC ;
 *)
 
 
+(*
+   getFunction - return the function associate with funccall node n.
+*)
+
+PROCEDURE getFunction (n: node) : node ;
+BEGIN
+   assert (isFuncCall (n)) ;
+   CASE n^.kind OF
+
+   funccall:  RETURN n^.funccallF.function
+
+   ELSE
+      HALT
+   END
+END getFunction ;
+
+
 (*
    getFuncFromExpr -
 *)
@@ -11701,7 +12675,9 @@ BEGIN
 END doStatementsC ;
 
 
-PROCEDURE stop ; END stop ;
+PROCEDURE localstop ;
+END localstop ;
+
 
 (*
    doLocalVarC -
@@ -11711,7 +12687,6 @@ PROCEDURE doLocalVarC (p: pretty; s: scopeT) ;
 BEGIN
    includeVarProcedure (s) ;
    debugLists ;
-
    topologicallyOut (doConstC, doTypesC, doVarC,
                      outputPartial,
                      doNone, doCompletePartialC, doNone)
@@ -13912,13 +14887,9 @@ END dumpQ ;
 *)
 
 PROCEDURE dumpLists ;
-VAR
-   m: String ;
 BEGIN
-   IF getDebugTopological ()
+   IF getDebugTopological () AND FALSE
    THEN
-      m := Sprintf0 (InitString ('\n')) ;
-      m := KillString (WriteS (StdOut, m)) ;
       dumpQ ('todo', globalGroup^.todoQ) ;
       dumpQ ('partial', globalGroup^.partialQ) ;
       dumpQ ('done', globalGroup^.doneQ)
@@ -14099,7 +15070,7 @@ BEGIN
       IF tryComplete (d, c, t, v)
       THEN
          alists.removeItemFromList (globalGroup^.todoQ, d) ;
-	 alists.includeItemIntoList (globalGroup^.doneQ, d) ;
+         addDone (d) ;
          i := 1
       ELSIF tryPartial (d, pt)
       THEN
@@ -14130,7 +15101,7 @@ BEGIN
       IF tryCompleteFromPartial (d, t)
       THEN
          alists.removeItemFromList (globalGroup^.partialQ, d) ;
-         alists.includeItemIntoList (globalGroup^.doneQ, d) ;
+         addDone (d) ;
          i := 1 ;
          DEC (n)
       ELSE
@@ -14144,7 +15115,7 @@ END tryOutputPartial ;
    debugList -
 *)
 
-PROCEDURE debugList (a: ARRAY OF CHAR; l: alist) ;
+PROCEDURE debugList (listName, symName: ARRAY OF CHAR; l: alist) ;
 VAR
    i, h: CARDINAL ;
    n   : node ;
@@ -14152,12 +15123,10 @@ BEGIN
    h := alists.noOfItemsInList (l) ;
    IF h>0
    THEN
-      outText (doP, a) ;
-      outText (doP, ' still contains node(s)\n') ;
       i := 1 ;
       REPEAT
          n := alists.getItemFromList (l, i) ;
-         dbg (n) ;
+         dbg (listName, symName, n) ;
          INC (i)
       UNTIL i > h
    END
@@ -14172,8 +15141,9 @@ PROCEDURE debugLists ;
 BEGIN
    IF getDebugTopological ()
    THEN
-      debugList ('todo', globalGroup^.todoQ) ;
-      debugList ('partial', globalGroup^.partialQ)
+      debugList ('todo', 'decl_node', globalGroup^.todoQ) ;
+      debugList ('partial', 'decl_node', globalGroup^.partialQ) ;
+      debugList ('done', 'decl_node', globalGroup^.doneQ)
    END
 END debugLists ;
 
@@ -14255,9 +15225,11 @@ BEGIN
    doFQNameC (p, n) ;
    outText (p, "_init") ;
    setNeedSpace (p) ;
-   outText (p, "(__attribute__((unused)) int argc") ;
-   outText (p, ",__attribute__((unused)) char *argv[]") ;
-   outText (p, ",__attribute__((unused)) char *envp[])\n");
+   outText (p, "(__attribute__((unused)) int argc,") ;
+   setNeedSpace (p) ;
+   outText (p, "__attribute__((unused)) char *argv[],") ;
+   setNeedSpace (p) ;
+   outText (p, "__attribute__((unused)) char *envp[])\n");
    p := outKc (p, "{\n") ;
    doStatementsC (p, n^.impF.beginStatements) ;
    p := outKc (p, "}\n") ;
@@ -14269,9 +15241,11 @@ BEGIN
    doFQNameC (p, n) ;
    outText (p, "_fini") ;
    setNeedSpace (p) ;
-   outText (p, "(__attribute__((unused)) int argc") ;
-   outText (p, ",__attribute__((unused)) char *argv[]") ;
-   outText (p, ",__attribute__((unused)) char *envp[])\n");
+   outText (p, "(__attribute__((unused)) int argc,") ;
+   setNeedSpace (p) ;
+   outText (p, "__attribute__((unused)) char *argv[],") ;
+   setNeedSpace (p) ;
+   outText (p, "__attribute__((unused)) char *envp[])\n");
    p := outKc (p, "{\n") ;
    doStatementsC (p, n^.impF.finallyStatements) ;
    p := outKc (p, "}\n")
@@ -14341,8 +15315,10 @@ BEGIN
    outText (p, "_init") ;
    setNeedSpace (p) ;
    outText (p, "(__attribute__((unused)) int argc,") ;
-   outText (p, " __attribute__((unused)) char *argv[]") ;
-   outText (p, " __attribute__((unused)) char *envp[])\n") ;
+   setNeedSpace (p) ;
+   outText (p, "__attribute__((unused)) char *argv[],") ;
+   setNeedSpace (p) ;
+   outText (p, "__attribute__((unused)) char *envp[])\n") ;
    p := outKc (p, "{\n") ;
    doStatementsC (p, n^.impF.beginStatements) ;
    p := outKc (p, "}\n") ;
@@ -14355,8 +15331,10 @@ BEGIN
    outText (p, "_fini") ;
    setNeedSpace (p) ;
    outText (p, "(__attribute__((unused)) int argc,") ;
-   outText (p, " __attribute__((unused)) char *argv[]") ;
-   outText (p, " __attribute__((unused)) char *envp[])\n") ;
+   setNeedSpace (p) ;
+   outText (p, "__attribute__((unused)) char *argv[],") ;
+   setNeedSpace (p) ;
+   outText (p, "__attribute__((unused)) char *envp[])\n") ;
    p := outKc (p, "{\n") ;
    doStatementsC (p, n^.impF.finallyStatements) ;
    p := outKc (p, "}\n") ;
@@ -14543,9 +15521,13 @@ BEGIN
       foreachDefModuleDo (runPrototypeDefC)
    ELSE
       s := InitStringCharStar (keyToCharStar (getSymName (n))) ;
-      (* we don't want to include the .h file for this implementation module.  *)
-      print (p, "#define _") ; prints (p, s) ; print (p, "_H\n") ;
+      (* Inform the source that this code belongs to the implementation module.  *)
       print (p, "#define _") ; prints (p, s) ; print (p, "_C\n\n") ;
+      (* Include the definition module for any opaque types.  *)
+      print (doP, '#include "') ;
+      prints (p, getHPrefix ()) ;
+      prints (p, s) ;
+      print (p, '.h"\n') ;
       s := KillString (s) ;
 
       doP := p ;
@@ -15442,8 +16424,15 @@ END setLangM2 ;
 *)
 
 PROCEDURE addDone (n: node) ;
+VAR
+   s: String ;
 BEGIN
-   alists.includeItemIntoList (globalGroup^.doneQ, n)
+   alists.includeItemIntoList (globalGroup^.doneQ, n) ;
+   IF isVar (n) OR isParameter (n)
+   THEN
+      initNodeOpaqueState (n)
+   END ;
+   debugLists
 END addDone ;
 
 
@@ -15464,6 +16453,11 @@ BEGIN
       metaError1 ('cyclic dependancy found between another module using {%1ad} from the definition module of the implementation main being compiled, use the --extended-opaque option to compile', n) ;
       flushErrors ;
       errorAbort0 ('terminating compilation')
+   ELSIF isType (n) AND isDeclInImp (n)
+   THEN
+      (* Ignore an opaque type which is declared in this implementation module as it
+         will be fully declared in C/C++ with the __opaque postfix.  Whereas the
+         void * non prefixed typedef will be declared in the .h file.  *)
    ELSE
       addDone (n)
    END
@@ -15704,7 +16698,7 @@ END doDbg ;
    dbg -
 *)
 
-PROCEDURE dbg (n: node) ;
+PROCEDURE dbg (listName, symName: ARRAY OF CHAR; n: node) ;
 VAR
    l: alist ;
    o: pretty ;
@@ -15720,10 +16714,20 @@ BEGIN
    l := alists.initList () ;
    alists.includeItemIntoList (l, n) ;
    i := 1 ;
-   out1 ("dbg (%s)\n", n) ;
    REPEAT
       n := alists.getItemFromList (l, i) ;
-      doDbg (l, n) ;
+      IF isType (n)
+      THEN
+         s := getFQstring (n) ;
+         IF EqualArray (s, symName)
+         THEN
+            out0 ("list ") ;
+            out0 (listName) ;
+            out0 (": ") ;
+            doDbg (l, n)
+         END ;
+         s := KillString (s)
+      END ;
       INC (i)
    UNTIL i>alists.noOfItemsInList (l) ;
    doP := o ;
@@ -16658,6 +17662,7 @@ BEGIN
    assert (isFuncCall (n)) ;
    m := makeFuncCall (dupExpr (n^.funccallF.function), dupExpr (n^.funccallF.args)) ;
    m^.funccallF.type := n^.funccallF.type ;
+   assignNodeOpaqueCastState (m, n) ;
    RETURN m
 END dupFunccall ;
 
diff --git a/gcc/m2/mc/mc.flex b/gcc/m2/mc/mc.flex
index 7c841bf8d63..26139516dfd 100644
--- a/gcc/m2/mc/mc.flex
+++ b/gcc/m2/mc/mc.flex
@@ -27,6 +27,7 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 
 #include <time.h>
 #include <ctype.h>
+#include <stdbool.h>
 
 #ifndef alloca
 #ifdef __GNUC__
@@ -101,11 +102,11 @@ static  void pushFunction             (char *function, int module);
 static  void popFunction              (void);
 static  void checkFunction            (void);
         int  mcflex_getColumnNo       (void);
-	int  mcflex_openSource        (char *s);
+	bool mcflex_openSource        (char *s);
 	int  mcflex_getLineNo         (void);
 	void mcflex_closeSource       (void);
 	char *mcflex_getToken         (void);
-        void _M2_mcflex_init          (void);
+        void _M2_mcflex_init          (int argc, char *argv[], char *envp[]);
         int  mcflex_getTotalLines     (void);
 extern  void  yylex                   (void);
 
@@ -659,13 +660,13 @@ mcflex_closeSource (void)
 /* openSource returns TRUE if file s can be opened and
    all tokens are taken from this file.  */
 
-int
+bool
 mcflex_openSource (char *s)
 {
   FILE *newInputFile = fopen (s, "r");
 
   if (newInputFile == NULL)
-    return FALSE;
+    return false;
   else
     {
       isDefinitionModule = FALSE;
@@ -687,7 +688,7 @@ mcflex_openSource (char *s)
       if (currentLine != NULL)
 	currentLine->actualline = lineno;
       START_FILE (filename, lineno);
-      return TRUE;
+      return true;
     }
 }
 
@@ -734,12 +735,12 @@ yywrap (void)
 }
 
 void
-_M2_mcflex_init (void)
+_M2_mcflex_init (int argc, char *argv[], char *envp[])
 {
 }
 
 void
-_M2_mcflex_fini (void)
+_M2_mcflex_fini (int argc, char *argv[], char *envp[])
 {
 }
 
diff --git a/gcc/m2/mc/mcComment.h b/gcc/m2/mc/mcComment.h
index 31f412fcf8a..9e75ca5e42a 100644
--- a/gcc/m2/mc/mcComment.h
+++ b/gcc/m2/mc/mcComment.h
@@ -22,6 +22,8 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 #ifndef mcCommentH
 #define mcCommentH
 
+#include <stdbool.h>
+
 /* addText the text cs is appended to the current comment.  */
 
 extern void mcComment_addText (void *cd, char *cs);
@@ -34,7 +36,7 @@ extern void mcComment_addText (void *cd, char *cs);
    If onlySpaces is TRUE then an inbody comment is created.
    If onlySpaces is FALSE then an after statement comment is created.  */
 
-extern void *mcComment_initComment (unsigned int onlySpaces);
+extern void *mcComment_initComment (bool onlySpaces);
 
 
 #endif
diff --git a/gcc/m2/mc/mcOptions.mod b/gcc/m2/mc/mcOptions.mod
index 7b81222f356..cdea1f466bf 100644
--- a/gcc/m2/mc/mcOptions.mod
+++ b/gcc/m2/mc/mcOptions.mod
@@ -752,7 +752,8 @@ BEGIN
       setOutputFile (Slice (arg, 3, 0))
    ELSIF optionIs ("--extended-opaque", arg)
    THEN
-      setExtendedOpaque (TRUE)
+      (* setExtendedOpaque (TRUE) *)
+      printf0 ("IGNORING --extended-opaque - this option is no longer implemented - please adjust the call to mc\n")
    ELSIF optionIs ("--debug-top", arg)
    THEN
       setDebugTopological (TRUE)
diff --git a/gcc/m2/mc/mcp1.bnf b/gcc/m2/mc/mcp1.bnf
index 5c1460b5517..5b9661b4c23 100644
--- a/gcc/m2/mc/mcp1.bnf
+++ b/gcc/m2/mc/mcp1.bnf
@@ -59,7 +59,7 @@ FROM mcLexBuf IMPORT currentstring, currenttoken, getToken, insertToken,
 FROM decl IMPORT node, lookupDef, lookupImp, lookupModule, getSymName,
                  lookupSym, putDefForC,
                  makeProcedure, makeType, makeTypeImp, makeVar, makeConst,
-		 enterScope, leaveScope, putTypeHidden,
+		 enterScope, leaveScope, putTypeHidden, putTypeOpaque,
 		 addImportedModule, getCurrentModule,
 		 putCommentDefProcedure, putCommentModProcedure ;
 
@@ -1064,7 +1064,8 @@ DefinitionModule :=                                                    % VAR c:
 
 DefTypeDeclaration := { Ident                                          % VAR n: node ; %
 		                                                       % n := makeType (curident) %
-                        ( ";"                                          % putTypeHidden (n) %
+                        ( ";"                                          % putTypeHidden (n) ;
+                                                                         putTypeOpaque (n) %
 			      | "=" Type Alignment ";" ) }
 		    =:
 
diff --git a/gcc/testsuite/gm2/base-lang/pass/SYSTEM.def b/gcc/testsuite/gm2/base-lang/pass/SYSTEM.def
new file mode 100644
index 00000000000..fde650bee24
--- /dev/null
+++ b/gcc/testsuite/gm2/base-lang/pass/SYSTEM.def
@@ -0,0 +1,197 @@
+(* SYSTEM.def provides access to the SYSTEM dependent module.
+
+Copyright (C) 2001-2024 Free Software Foundation, Inc.
+Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.
+
+This file is part of GNU Modula-2.
+
+GNU Modula-2 is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GNU Modula-2 is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+Under Section 7 of GPL version 3, you are granted additional
+permissions described in the GCC Runtime Library Exception, version
+3.1, as published by the Free Software Foundation.
+
+You should have received a copy of the GNU General Public License and
+a copy of the GCC Runtime Library Exception along with this program;
+see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+<http://www.gnu.org/licenses/>.  *)
+
+DEFINITION MODULE SYSTEM ;
+
+EXPORT QUALIFIED BITSPERBYTE, BYTESPERWORD,
+                 ADDRESS, WORD, BYTE, CSIZE_T, CSSIZE_T, (* @SYSTEM_DATATYPES@  *)
+                 ADR, TSIZE, ROTATE, SHIFT, THROW, TBITSIZE ;
+                 (* SIZE is also exported if -fpim2 is used.  *)
+
+CONST
+  BITSPERBYTE   = __ATTRIBUTE__ __BUILTIN__ ((BITS_PER_UNIT)) ;
+  BYTESPERWORD  = __ATTRIBUTE__ __BUILTIN__ ((UNITS_PER_WORD)) ;
+
+(* Note that the full list of system and sized datatypes include:
+   LOC, WORD, BYTE, ADDRESS,
+
+   (and the non language standard target types)
+
+   INTEGER8, INTEGER16, INTEGER32, INTEGER64,
+   CARDINAL8, CARDINAL16, CARDINAL32, CARDINAL64,
+   WORD16, WORD32, WORD64, BITSET8, BITSET16,
+   BITSET32, REAL32, REAL64, REAL128, COMPLEX32,
+   COMPLEX64, COMPLEX128, CSIZE_T, CSSIZE_T.
+
+   Also note that the non-standard data types will
+   move into another module in the future.  *)
+
+
+(* The following types are supported on this target:
+TYPE
+   @SYSTEM_TYPES@
+*)
+
+
+(*
+   all the functions below are declared internally to gm2
+   ======================================================
+
+PROCEDURE ADR (VAR v: <anytype>): ADDRESS;
+  (* Returns the address of variable v. *)
+
+PROCEDURE SIZE (v: <type>) : ZType;
+  (* Returns the number of BYTES used to store a v of
+     any specified <type>.  Only available if -fpim2 is used.
+  *)
+
+PROCEDURE TSIZE (<type>) : CARDINAL;
+  (* Returns the number of BYTES used to store a value of the
+     specified <type>.
+  *)
+
+PROCEDURE ROTATE (val: <a set type>;
+                  num: INTEGER): <type of first parameter>;
+  (* Returns a bit sequence obtained from val by rotating up/right
+     or down/right by the absolute value of num.  The direction is
+     down/right if the sign of num is negative, otherwise the direction
+     is up/left.
+  *)
+
+PROCEDURE SHIFT (val: <a set type>;
+                 num: INTEGER): <type of first parameter>;
+  (* Returns a bit sequence obtained from val by shifting up/left
+     or down/right by the absolute value of num, introducing
+     zeros as necessary.  The direction is down/right if the sign of
+     num is negative, otherwise the direction is up/left.
+  *)
+
+PROCEDURE THROW (i: INTEGER) <* noreturn *> ;
+  (*
+     THROW is a GNU extension and was not part of the PIM or ISO
+     standards.  It throws an exception which will be caught by the
+     EXCEPT block (assuming it exists).  This is a compiler builtin
+     function which interfaces to the GCC exception handling runtime
+     system.
+     GCC uses the term throw, hence the naming distinction between
+     the GCC builtin and the Modula-2 runtime library procedure Raise.
+     The later library procedure Raise will call SYSTEM.THROW after
+     performing various housekeeping activities.
+  *)
+
+PROCEDURE TBITSIZE (<type>) : CARDINAL ;
+  (* Returns the minimum number of bits necessary to represent
+     <type>.  This procedure function is only useful for determining
+     the number of bits used for any type field within a packed RECORD.
+     It is not particularly useful elsewhere since <type> might be
+     optimized for speed, for example a BOOLEAN could occupy a WORD.
+  *)
+*)
+
+(* The following procedures are invoked by GNU Modula-2 to
+   shift non word sized set types. They are not strictly part
+   of the core PIM Modula-2, however they are used
+   to implement the SHIFT procedure defined above,
+   which are in turn used by the Logitech compatible libraries.
+
+   Users will access these procedures by using the procedure
+   SHIFT above and GNU Modula-2 will map SHIFT onto one of
+   the following procedures.
+*)
+
+(*
+   ShiftVal - is a runtime procedure whose job is to implement
+              the SHIFT procedure of ISO SYSTEM. GNU Modula-2 will
+              inline a SHIFT of a single WORD sized set and will only
+              call this routine for larger sets.
+*)
+
+PROCEDURE ShiftVal (VAR s, d: ARRAY OF BITSET;
+                    SetSizeInBits: CARDINAL;
+                    ShiftCount: INTEGER) ;
+
+
+(*
+   ShiftLeft - performs the shift left for a multi word set.
+               This procedure might be called by the back end of
+               GNU Modula-2 depending whether amount is known at
+               compile time.
+*)
+
+PROCEDURE ShiftLeft (VAR s, d: ARRAY OF BITSET;
+                     SetSizeInBits: CARDINAL;
+                     ShiftCount: CARDINAL) ;
+
+(*
+   ShiftRight - performs the shift left for a multi word set.
+                This procedure might be called by the back end of
+                GNU Modula-2 depending whether amount is known at
+                compile time.
+*)
+
+PROCEDURE ShiftRight (VAR s, d: ARRAY OF BITSET;
+                      SetSizeInBits: CARDINAL;
+                      ShiftCount: CARDINAL) ;
+
+
+(*
+   RotateVal - is a runtime procedure whose job is to implement
+               the ROTATE procedure of ISO SYSTEM. GNU Modula-2 will
+               inline a ROTATE of a single WORD (or less)
+               sized set and will only call this routine for larger
+               sets.
+*)
+
+PROCEDURE RotateVal (VAR s, d: ARRAY OF BITSET;
+                     SetSizeInBits: CARDINAL;
+                     RotateCount: INTEGER) ;
+
+
+(*
+   RotateLeft - performs the rotate left for a multi word set.
+                This procedure might be called by the back end of
+                GNU Modula-2 depending whether amount is known at
+                compile time.
+*)
+
+PROCEDURE RotateLeft (VAR s, d: ARRAY OF BITSET;
+                      SetSizeInBits: CARDINAL;
+                      RotateCount: CARDINAL) ;
+
+
+(*
+   RotateRight - performs the rotate right for a multi word set.
+                 This procedure might be called by the back end of
+                 GNU Modula-2 depending whether amount is known at
+                 compile time.
+*)
+
+PROCEDURE RotateRight (VAR s, d: ARRAY OF BITSET;
+                       SetSizeInBits: CARDINAL;
+                       RotateCount: CARDINAL) ;
+
+
+END SYSTEM.
diff --git a/gcc/testsuite/gm2/base-lang/pass/base-lang-test.sh b/gcc/testsuite/gm2/base-lang/pass/base-lang-test.sh
new file mode 100755
index 00000000000..de33018775f
--- /dev/null
+++ b/gcc/testsuite/gm2/base-lang/pass/base-lang-test.sh
@@ -0,0 +1,291 @@
+#!/bin/sh
+# Copyright (C) 2024 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GCC; see the file COPYING3.  If not see
+# <http://www.gnu.org/licenses/>.
+
+# This file was written by Gaius Mulley (gaiusmod2@gmail.com)
+
+# This script performs base language translation tests with the bootstrap tool mc.
+
+MC=$1
+GCCSRCDIR=$2
+GCCBUILDDIR=$3
+GXX=$4
+
+
+SCRATCHDIR=${GCCBUILDDIR}/m2/mc-base-lang-test
+
+
+function compile () {
+    echo $*
+    if ! $* ; then
+	echo $*
+	echo "bootstrap compiler ${MC} failed: $*"
+	exit 1
+    fi
+}
+
+
+function compile_def () {
+    SRC=$1
+    compile ${MC} -o=${SCRATCHDIR}/G${SRC}.h --olang=c++  --h-file-prefix=G --quiet \
+	    -I${GCCSRCDIR}/m2/gm2-libs -I${GCCSRCDIR}/testsuite/gm2/base-lang/pass \
+	    ${GCCSRCDIR}/testsuite/gm2/base-lang/pass/${SRC}.def
+}
+
+
+function compile_mod () {
+    SRC=$1
+    compile ${MC} -o=${SCRATCHDIR}/G${SRC}.cc --olang=c++  --h-file-prefix=G --quiet \
+	    -I${GCCSRCDIR}/m2/gm2-libs -I${GCCSRCDIR}/testsuite/gm2/base-lang/pass \
+	    ${GCCSRCDIR}/testsuite/gm2/base-lang/pass/${SRC}.mod
+}
+
+
+#
+#  verify - check that the translated sources compile with -Wodr
+#
+
+function verify () {
+    SRC=$1
+    if ${GXX} -Wodr -Werror -I${SCRATCHDIR} -c ${SCRATCHDIR}/G${SRC}.cc -o ${SCRATCHDIR}/G${SRC}.o ; then
+	echo "${NAME}: Passed"
+    else
+	echo "${NAME}: Failed (${GXX} -Wodr -Werror -I${SCRATCHDIR} -c ${SCRATCHDIR}/G${SRC}.cc)"
+	exit 1
+    fi
+}
+
+
+function localvar () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="local variable creation"
+    compile_def localvar
+    compile_mod localvar
+    verify localvar
+}
+
+
+function globalvar () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="global variable creation"
+    compile_def globalvar
+    compile_mod globalvar
+    verify globalvar
+}
+
+
+function localvarassign () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="local variable assignment"
+    compile_def localvarassign
+    compile_mod localvarassign
+    verify localvarassign
+}
+
+
+function globalvarassign () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="global variable assignment"
+    compile_def globalvarassign
+    compile_mod globalvarassign
+    verify globalvarassign
+}
+
+
+function localproctype () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="local proctype creation"
+    compile_def localproctype
+    compile_mod localproctype
+    verify localproctype
+}
+
+
+function globalproctype () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="global proctype creation"
+    compile_def globalproctype
+    compile_mod globalproctype
+    verify globalproctype
+}
+
+
+function simpleopaque () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="simple opaque type creation"
+    compile_def simpleopaque
+    compile_mod simpleopaque
+    verify simpleopaque
+}
+
+
+function simplelist () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="simple list opaque type field manipulation"
+    compile_def simplelist
+    compile_mod simplelist
+    verify simplelist
+}
+
+
+function simplelistiter () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="simple iteration using opaque type field"
+    compile_def simplelistiter
+    compile_mod simplelistiter
+    verify simplelistiter
+}
+
+
+function opaqueparam () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="opaque parameter and field assignment"
+    compile_def opaqueparam
+    compile_mod opaqueparam
+    verify opaqueparam
+}
+
+
+function opaqueuse () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="opaque use"
+    compile_def opaqueparam
+    compile_def opaqueuse
+    compile_mod opaqueuse
+    verify opaqueuse
+}
+
+
+function opaquestr () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="opaque str"
+    compile_def opaquestr
+    compile_def opaqueusestr
+    compile_mod opaqueusestr
+    verify opaqueusestr
+}
+
+
+function opaquenew () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="opaque new"
+    compile_def opaquenew
+    compile_mod opaquenew
+    verify opaquenew
+}
+
+
+function opaquefield () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="opaque field"
+    compile_def opaquestr
+    compile_def opaquefield
+    compile_mod opaquefield
+    verify opaquefield
+}
+
+
+function opaquevariant () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="opaque variant"
+    compile_def opaquevariant
+    compile_mod opaquevariant
+    verify opaquevariant
+}
+
+
+function opaquevarparam () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="opaque variant"
+    compile_def opaquevarparam
+    compile_mod opaquevarparam
+    verify opaquevarparam
+}
+
+
+function straddress () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="string address"
+    compile_def SYSTEM
+    compile_def straddress
+    compile_mod straddress
+    verify straddress
+}
+
+
+function straddressexport () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="string address"
+    compile_def SYSTEM
+    compile_def straddressexport
+    compile_mod straddressexport
+    verify straddressexport
+}
+
+
+function unboundedarray () {
+    rm -rf ${SCRATCHDIR}
+    mkdir -p ${SCRATCHDIR}
+    NAME="string address"
+    compile_def unboundedarray
+    compile_mod unboundedarray
+    verify unboundedarray
+}
+
+
+function runall () {
+    localvar
+    globalvar
+    localvarassign
+    globalvarassign
+    localproctype
+    globalproctype
+    simpleopaque
+    simplelist
+    simplelistiter
+    opaqueparam
+    opaqueuse
+    opaquestr
+    opaquenew
+    opaquefield
+    opaquevariant
+    opaquevarparam
+    straddress
+    straddressexport
+    unboundedarray
+    echo "all base language boot strap tests pass -Wodr -Werror"
+}
+
+
+runall
diff --git a/gcc/testsuite/gm2/base-lang/pass/globalproctype.def b/gcc/testsuite/gm2/base-lang/pass/globalproctype.def
new file mode 100644
index 00000000000..ce52321495a
--- /dev/null
+++ b/gcc/testsuite/gm2/base-lang/pass/globalproctype.def
@@ -0,0 +1,7 @@
+DEFINITION MODULE globalproctype ;  (*!m2pim*)
+
+TYPE
+   myproc = PROCEDURE (CARDINAL) ;
+
+
+END globalproctype.
